Ext.define('flextable.Api', {singleton:true, getConnectionInfo:function(moduleId) {
  return this.getStats(moduleId).then(function(statsObject) {
    return (statsObject || {}).connection;
  });
}, getDriverInfo:function(moduleId, params) {
  params = params === undefined ? {mode:'driver'} : params;
  return this.loadInfoData(moduleId, params);
}, getTablesViews:function(moduleId, params) {
  params = params === undefined ? {mode:'tables'} : params;
  return this.loadInfoData(moduleId, params);
}, getSchemas:function(moduleId, params) {
  params = params === undefined ? {mode:'schemas'} : params;
  return this.loadInfoData(moduleId, params);
}, getCatalogs:function(moduleId, params) {
  params = params === undefined ? {mode:'catalogs'} : params;
  return this.loadInfoData(moduleId, params);
}, loadInfoData:function(moduleId, params) {
  return flextable.Support.newRequest(flextable.Support.basePath + moduleId + '/info?' + Ext.Object.toQueryString(params), undefined, undefined).then(function(json) {
    json = json || {};
    var meta = json.meta || {};
    return function() {
      var $jscomp$destructuring$var0 = meta;
      var $jscomp$destructuring$var1 = $jscomp$destructuring$var0;
      connection = $jscomp$destructuring$var1.connection;
      return $jscomp$destructuring$var0;
    }();
  }).then(function(statsObject) {
    return (statsObject || {}).connection;
  });
}, getTableMeta:function(moduleId, tableName) {
  return this.loadInfoData(moduleId, {mode:'tableInfo', table:tableName});
}, getStats:function(moduleId, tableName) {
  var params = {};
  if (tableName) {
    params.table = tableName;
  }
  return flextable.Support.newRequest(flextable.Support.basePath + moduleId + '/info?' + Ext.Object.toQueryString(params), undefined, undefined).then(function(json) {
    json = json || {};
    var meta = json.meta || {};
    return function() {
      var $jscomp$destructuring$var2 = meta;
      var $jscomp$destructuring$var3 = $jscomp$destructuring$var2;
      connection = $jscomp$destructuring$var3.connection;
      return $jscomp$destructuring$var2;
    }();
  });
}});
Ext.define('flextable.widget.Wrapper', {extend:'Ext.panel.Panel', alias:'widget.flextableWidget', mixins:['BpcCommon.mixin.Widget'], statics:{WIDGET_NAME:'Flextable Widget', WIDGET_DESCRIPTION:'TableView -  Main / Details', WIDGET_ICON_CLS:'x-fal fa-table'}, widgetConfigSettingMap:{moduleId:{settingType:'moduleInstance'}}, config:{widgetConfiguration:{moduleId:undefined}}, layout:'card', moduleId:undefined, widgetId:undefined, initComponent:function() {
  try {
    this.initWidgetSettings();
  } catch (e) {
  }
  this.callParent(arguments);
  this.initWidget();
  this.settingPanel = this.add({xtype:'bpcSettingPanel', settings:this.settingStore, buttons:[{text:flextable.Support.getTranslation('OK'), handler:this.configureWidget.bind(this)}]});
}, initWidget:function() {
  this.wrapper = this.add(this.moduleId ? {xtype:'flextableMain', moduleId:this.moduleId, isBpcModule:false, showToolbars:false} : {xtype:'container', html:flextable.Support.getTranslation('CONFIG_ERROR_NO_MODULEID_DEFINED'), load:Ext.emptyFn()});
}, refreshWidget:function() {
  this.wrapper.load();
}, configureWidget:function() {
  this.getLayout().setActiveItem(this.settingPanel.isVisible(true) ? this.wrapper : this.settingPanel);
}});
Ext.define('flextable.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:['flextable.widget.Wrapper'], config:{moduleConfigurationComponents:['flextableConfigMain'], requiredModules:[], widgets:['flextable.widget.Wrapper'], version:'3.5.1', build:'v3.3.6-29-g7eb8897-2022-05-10T16:19:47+0200'}});
Ext.define('flextable.Support', {singleton:true, keys:{cfg:'uiConfiguration', id:'idColumn'}, icons:{instance:'fa-th-list', module:'fa-th-list'}, iconTypePrefix:'x-fal', iconPrefix:'fa-', basePath:'/cxf/bpc-flextable/', getBpcIconCls:function(fontAwesomeName) {
  fontAwesomeName = fontAwesomeName || '';
  fontAwesomeName = fontAwesomeName.trim();
  if (this.isLegacyIconCls(fontAwesomeName)) {
    return 'fa-lg ' + fontAwesomeName;
  }
  if (Ext.String.startsWith(fontAwesomeName, this.iconTypePrefix)) {
    return fontAwesomeName;
  }
  if (!Ext.String.startsWith(fontAwesomeName, this.iconPrefix)) {
    fontAwesomeName = this.iconPrefix + fontAwesomeName;
  }
  return this.iconTypePrefix + ' ' + fontAwesomeName;
}, defaultFontSize:14, defaultFontUnit:'px', fallbackIconColor:'#eee', marginRight:3, isLegacyIconCls:function(fontAwesomeName) {
  var iconClasses = fontAwesomeName.split(' ');
  return iconClasses.length > 0 && iconClasses.indexOf('fa') !== -1;
}, getResponseObject:function(responseObj) {
  responseObj = responseObj || {};
  if ('responseText' in responseObj && responseObj.responseText) {
    return Ext.decode(responseObj.responseText, true);
  } else {
    if ('responseJson' in responseObj && responseObj.responseJson) {
      return responseObj.responseJson;
    }
  }
}, getSpanForIconCls:function(iconCls, color, size) {
  var legacy = this.isLegacyIconCls(iconCls);
  iconCls = this.getBpcIconCls(iconCls);
  size = size || this.defaultFontSize;
  size += this.defaultFontUnit;
  color = color || this.fallbackIconColor;
  var marginRight = this.marginRight;
  var style = 'color:' + color + ';' + (legacy ? '' : 'font-size:' + size + ';') + 'margin-right:' + marginRight + ';';
  return '\x3cspan class\x3d"' + iconCls + '" style\x3d"' + style + '"\x3e\x3c/span\x3e';
}, newRequest:function(url, params, data, method) {
  params = params === undefined ? {} : params;
  data = data === undefined ? null : data;
  method = method === undefined ? 'GET' : method;
  return new Promise(function(resolve, reject) {
    Ext.Ajax.request({url:url, params:params, method:method, jsonData:data, headers:{'Content-Type':'application/json'}, success:function(response) {
      resolve(response.responseText ? Ext.decode(response.responseText, true) : {});
    }, failure:function(response) {
      reject(response);
    }});
  });
}, getTranslation:function(key, uppercase, splitWhitespaceWithBr) {
  key = key.toUpperCase();
  var starter = 'FLEXTABLE_';
  if (!Ext.String.startsWith(key, starter)) {
    key = starter + key;
  }
  var translation = BpcCommon.Api.getTranslation(key);
  if (key === translation) {
  }
  translation = uppercase ? translation.toUpperCase() : translation;
  return splitWhitespaceWithBr ? translation.replace(' ', '\x3cbr\x3e') : translation;
}, getWindow:function(title, iconCls, width, height, cmpAlias, cmpConfig) {
  var w = Ext.create('Ext.window.Window', {title:title || '', height:height || document.body.clientHeight * 0.8, width:width || document.body.clientWidth * 0.6, layout:'fit', iconCls:flextable.Support.getBpcIconCls(iconCls || 'fa-info')});
  cmpConfig = cmpConfig || {};
  cmpConfig.windowReference = w;
  cmpConfig.closeWindow = function() {
    w.close();
  };
  w.add(Ext.create(Ext.apply({xtype:cmpAlias}, cmpConfig)));
  return w;
}, resourcesBasePath:'/bpc-fe-flextable/', getAjaxPromise:function(requestOptions) {
  return new Promise(function(resolve, reject) {
    Ext.Ajax.request(requestOptions).then(function(response) {
      resolve(response);
    }, function(error) {
      reject(error);
    });
  });
}, copyToClipBoard:function(text, extCmp) {
  function copyToClp(stringWithNewLines) {
    try {
      var myFluffyTextarea = document.createElement('textarea');
      myFluffyTextarea.innerHTML = stringWithNewLines;
      var parentElement = document.getElementById(extCmp.getId());
      parentElement.appendChild(myFluffyTextarea);
      myFluffyTextarea.select();
      document.execCommand('copy');
      parentElement.removeChild(myFluffyTextarea);
      return true;
    } catch (e) {
      return false;
    }
  }
  return copyToClp(text);
}, getBackendConnectionId:function(instanceId) {
  return BpcCommon.Api.getSetting(instanceId, 'proxyId');
}, mimeTypeMap:{'application/pdf':'fa-file-pdf', 'text/plain':'fa-file-alt', 'application/vnd.openxmlformats-officedocument.wordprocessingml.document':'fa-file-word', 'application/xml':'fa-file-code', 'text/xml':'fa-file-code', 'application/edifact':'fa-file-code', 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet':'fa-file-excel', 'other':'fa-file'}, prettyXml:function(xml, tab, nl) {
  tab = tab === undefined ? '\t' : tab;
  nl = nl === undefined ? '\n' : nl;
  var formatted = '', indent = '';
  var nodes = xml.slice(1, -1).split(/>\s*</);
  if (nodes[0][0] === '?') {
    formatted += '\x3c' + nodes.shift() + '\x3e' + nl;
  }
  for (var i = 0; i < nodes.length; i++) {
    var node = nodes[i];
    if (node[0] === '/') {
      indent = indent.slice(tab.length);
    }
    formatted += indent + '\x3c' + node + '\x3e' + nl;
    if (node[0] !== '/' && node[node.length - 1] !== '/' && node.indexOf('\x3c/') === -1) {
      indent += tab;
    }
  }
  return formatted;
}, objectToHtmlTable:function(obj, keys, trPrefix) {
  keys = keys === undefined ? [] : keys;
  trPrefix = trPrefix === undefined ? '' : trPrefix;
  obj = obj || {};
  var html = '\x3ctable style\x3d"width: 300px"\x3e';
  Object.keys(obj).filter(function(k) {
    return keys.length ? keys.indexOf(k) !== -1 : true;
  }).map(function(k) {
    html += '\x3ctr\x3e';
    html += '\x3ctd style\x3d"width: 120px"\x3e' + (trPrefix.length ? documents.Support.TR(trPrefix + k) : k) + '\x3c/td\x3e';
    html += '\x3ctd style\x3d"width: 180px"\x3e' + obj[k] + '\x3c/td\x3e';
    html += '\x3c/tr\x3e';
  });
  return html + '\x3c/table\x3e';
}, preloadPluginModules:function(moduleId) {
  var $jscomp$this = this;
  var deferred = new Ext.Deferred;
  var cfg = BpcCommon.Api.getSetting('flextable', 'plugin_configuration') || [];
  var sourceModuleNames = cfg.filter(function(cfg) {
    return Ext.isDefined(cfg.sourceModule) && cfg.sourceModule !== null;
  }).map(function(cfg) {
    return cfg.sourceModule;
  });
  sourceModuleNames = Ext.Array.unique(sourceModuleNames);
  var pluginSettingValuesForModuleId = moduleId ? cfg.filter(function(settingsValue) {
    return settingsValue.targetInstance && Ext.isArray(settingsValue.targetInstance) && settingsValue.targetInstance.indexOf(moduleId) !== -1;
  }) : [];
  if (this.pluginMap[moduleId]) {
    var settings = this.pluginMap[moduleId];
    deferred.resolve(JSON.parse(JSON.stringify(settings)));
  } else {
    var moduleLoadPromises = sourceModuleNames.map(function(moduleName) {
      return BpcCommon.Api.loadModule(moduleName);
    });
    Promise.all(moduleLoadPromises).then(function() {
      $jscomp$this.pluginMap[moduleId] = pluginSettingValuesForModuleId;
      deferred.resolve(pluginSettingValuesForModuleId);
    }, function() {
      deferred.resolve(false);
    });
  }
  return deferred.promise;
}, pluginMap:{}, pluginsLoaded:false, getPlugins:function(instanceId) {
  var pluginConfigurations = BpcCommon.Api.getSetting('flextable', 'plugin_configuration') || [];
  return pluginConfigurations.filter(function(conf) {
    return Ext.isDefined(conf.targetInstance) && Ext.isArray(conf.targetInstance) && conf.targetInstance.indexOf(instanceId) !== -1;
  });
}});
Ext.define('flextable.components.DetailPanel', {extend:'Ext.panel.Panel', alias:'widget.flextableDetailPanel', layout:{type:'vbox', align:'stretch'}, header:false, initComponent:function() {
  var defaults = {record:this.record, moduleInstance:this.moduleInstance};
  var processViewer = {xtype:'container', layout:{type:'hbox', align:'stretch'}, record:undefined, moduleInstance:undefined, createItemView:function() {
    var me = this;
    return me.add({xtype:'fieldset', flex:1, layout:{type:'vbox', align:'stretch'}, title:flextable.Support.getTranslation('INFORMATIONS'), record:me.record, moduleInstance:me.moduleInstance, getFlexItem:function(rawKey, rawValue) {
      var me = this;
      rawKey = rawKey || '';
      rawValue = rawValue || '';
      if (me.moduleInstance) {
        var columns = me.moduleInstance.getColumn(rawKey);
        if (columns.length && columns[0].renderer) {
          rawValue = columns[0].renderer(rawValue);
          rawKey = columns[0].text || rawKey;
        }
      }
      return '\x3cdiv style\x3d"display: flex; flex-direction: row"\x3e\x3cdiv style\x3d"flex-grow: 1;max-width: 15%"\x3e' + rawKey + ': \x3c/div\x3e\x3cdiv style\x3d"flex-grow: 3"\x3e' + rawValue + '\x3c/div\x3e\x3c/div\x3e';
    }, addItemsFromRecord:function() {
      var me = this;
      var obj = me.record.getData() || {};
      Object.keys(obj).filter(function(k) {
        return k !== 'R__' && k !== 'id';
      }).map(function(key) {
        me.add({xtype:'box', html:me.getFlexItem(key, obj[key])});
      });
    }});
  }, flex:1};
  var containerBase = {xtype:'container', layout:'fit', items:[], flex:1};
  this.topContainer = Ext.create(Ext.apply({}, containerBase, defaults));
  this.mainContainer = Ext.create(Ext.apply({}, containerBase, defaults));
  this.items = [this.topContainer, {xtype:'splitter'}, this.mainContainer];
  this.callParent(arguments);
  var processViewerCmp = this.topContainer.add(Ext.apply(processViewer, defaults));
  processViewerCmp.createItemView().addItemsFromRecord();
  var tabPanel = this.mainContainer.add({xtype:'tabpanel'});
  var detailGrid = tabPanel.add({xtype:'flextableGrid', moduleId:this.moduleId, moduleInstance:this.moduleInstance, mode:'details', title:flextable.Support.getTranslation('LOG_STEPS')});
  tabPanel.setActiveTab(detailGrid);
  detailGrid.changeExtraParams({idValue:this.record.get(BpcCommon.Api.getSetting(this.moduleId, flextable.Support.keys.id))});
  detailGrid.store.load();
}});
Ext.define('flextable.components.Grid', {extend:'Ext.grid.Panel', alias:'widget.flextableGrid', moduleId:undefined, columns:undefined, idKey:undefined, flexContext:undefined, openDetailWindow:function(rec) {
  var w = flextable.Support.getWindow(rec.get(BpcCommon.Api.getSetting(this.moduleId, flextable.Support.keys.id)), undefined, undefined, undefined, 'flextableDetailPanel', {record:rec, moduleId:this.moduleId, moduleInstance:this.moduleInstance});
  w.show();
}, getActionColumn:function() {
  return {xtype:'actioncolumn', width:50, items:[]};
}, connectionDetails:{}, initComponent:function() {
  var $jscomp$this = this;
  this.totalBtn = Ext.create({xtype:'button', iconCls:flextable.Support.getBpcIconCls('fa-database'), text:'0', listeners:{afterRender:function(b) {
    if (BpcCommon.Api.hasUserAnyRole(['bpcadmin'])) {
      Ext.create({xtype:'tooltip', target:b, listeners:{beforeshow:function(tip) {
        tip.setHtml(flextable.Support.objectToHtmlTable($jscomp$this.connectionDetails));
      }}});
    }
  }}});
  var listeners = {};
  this.viewConfig = {emptyText:flextable.Support.getTranslation('NO_DATA'), enableTextSelection:true};
  var fieldsDefinition = [];
  if (this.mode === 'details') {
    var idFieldForDetails = BpcCommon.Api.getSetting(this.moduleId, 'idColumnDetailSub');
    fieldsDefinition.push({name:idFieldForDetails, sortType:'asInt'});
  }
  this.store = Ext.create('Ext.data.Store', {fields:fieldsDefinition, proxy:{type:'ajax', url:'/cxf/bpc-flextable/' + this.moduleId + '/data', reader:{type:'json', rootProperty:'items', totalProperty:'total'}, listeners:{exception:function(p, response, operation) {
    $jscomp$this.handleError(Ext.decode(response.responseText, true));
  }}}, autoLoad:false, _grid:this, columnsAdded:undefined, listeners:{load:function(store, records, success, operation) {
    if (success) {
      if (!store.columnsAdded) {
        $jscomp$this.setColumnsFromRecord(records.length ? records[0] : Ext.create('Ext.data.Model', {NO_DATA:undefined}));
      }
      $jscomp$this.updateTotal();
      var response = operation.getResponse();
      var json = flextable.Support.getResponseObject(response);
      if (json && json.meta && json.meta.connection) {
        $jscomp$this.connectionDetails = json.meta.connection;
      }
    } else {
      if (!store.columnsAdded) {
        $jscomp$this.setColumnsFromRecord(Ext.create('Ext.data.Model', {NO_DATA:undefined}));
      }
    }
  }}});
  var definedColumns = this.getColumnsFromSetting(this.mode || 'main');
  var columns = definedColumns ? this.getActionColumnConfig(this.moduleId).concat(definedColumns) : undefined;
  var actionColumn = this.getActionColumn();
  var pluginDefinitions = this.getPluginDefinitions();
  if (pluginDefinitions && pluginDefinitions.length) {
    var instances = pluginDefinitions.map(function(i) {
      return Ext.create(i);
    });
    if (instances.length === 1) {
      var o = instances[0].getPluginAction(this);
      if (o) {
        actionColumn.items.push(o);
      }
    }
  }
  var actionColPrefix = BpcCommon.Api.getSetting(this.moduleId, 'actionColumnPrefix');
  var actionListener = BpcCommon.Api.getSetting(this.moduleId, 'actionListener');
  var actionActive = actionListener !== null && actionListener !== undefined;
  if (actionActive) {
    actionColumn.items.push({iconCls:flextable.Support.getBpcIconCls('fa-play'), tooltip:'Aktionen starten', handler:function(grid, rowIndex, colIndex, item, e, record) {
      var actions = [];
      var actionColumns = Object.keys(record.data).filter(function(i) {
        if (i && Ext.isString(i)) {
          return i.startsWith(actionColPrefix);
        }
        return false;
      }).map(function(name) {
        var actionString = record.get(name);
        actionString.split(',').map(function(i) {
          i = i || '';
          return i.trim();
        }).filter(function(i) {
          return i.length > 0;
        }).map(function(i) {
          actions.push({text:i});
        });
      });
      Ext.create('Ext.menu.Menu', {margin:'0 0 10 0', floating:true, items:actions.map(function(i) {
        i.record = record;
        i.iconCls = flextable.Support.getBpcIconCls('fa-play-circle');
        i.handler = function(m) {
          $jscomp$this.runAction(m.text, m.record);
        };
        return i;
      })}).showAt(e.getXY());
    }, isActionDisabled:function(view, rowIndex, colIndex, item, record) {
      if (record && record.data) {
        var actionColumns = Object.keys(record.data).filter(function(i) {
          if (i && Ext.isString(i)) {
            return i.startsWith(actionColPrefix);
          }
          return false;
        });
        return actionColumns.length === 0;
      }
      return true;
    }});
  }
  if (actionColumn.items.length && columns) {
    actionColumn.width = actionColumn.items.length * 30;
    columns.push(actionColumn);
  }
  this.columns = columns;
  listeners.rowdblclick = function(tableView, record) {
    if ($jscomp$this.moduleInstance.isBpcModule && $jscomp$this.mode !== 'details') {
      $jscomp$this.openDetailWindow(record);
    } else {
      if (!$jscomp$this.moduleInstance.isBpcModule && $jscomp$this.mode === 'details' && $jscomp$this.getAttachment(record)) {
        $jscomp$this.openAttachment(record);
      }
    }
  };
  this.plugins = this.idKey ? [{ptype:'rowwidget', widget:{xtype:'container', layout:'fit', items:[]}, _grid:this, onWidgetAttach:function(plugin, cmp, record) {
    cmp.removeAll();
    var gridCmp = cmp.add({xtype:'flextableGrid', moduleId:plugin._grid.moduleId, moduleInstance:plugin._grid.moduleInstance, mode:'details'});
    var pid = record.get(plugin._grid.idKey);
    if (pid) {
      gridCmp.changeExtraParams({idValue:pid});
      gridCmp.store.load();
    }
  }}] : [];
  this.store.columnsAdded = !!(Ext.isDefined(this.columns) && this.columns.length);
  if (!Ext.isDefined(this.columns)) {
    this.columns = [];
  }
  if (this.moduleInstance.showToolbars) {
    this.bbar = [this.totalBtn, {xtype:'tbfill'}];
  }
  this.listeners = listeners;
  this.callParent(arguments);
}, getEngineBaseUrl:function() {
  var proxyId = BpcCommon.Api.getSetting(this.moduleId, 'engineConnection');
  return BpcCommon.Api.getBackendUrl(proxyId) + BpcCommon.Api.getSetting(this.moduleId, 'engineBasePath');
}, runAction:function(action, record) {
  var cfg = BpcCommon.Api.getSetting(this.moduleId, 'actionConfig') || {};
  var urlParams = {}, url = this.getEngineBaseUrl() + BpcCommon.Api.getSetting(this.moduleId, 'actionListener');
  if (cfg.params && Ext.isObject(cfg.params) && !Ext.isEmpty(cfg.params)) {
    urlParams = Ext.apply(urlParams, cfg.params);
  }
  var actionPrefix = BpcCommon.Api.getSetting(this.moduleId, 'actionColumnPrefix');
  actionPrefix = actionPrefix || '';
  actionPrefix = actionPrefix.toLowerCase();
  urlParams[actionPrefix] = action;
  urlParams.buttonId = actionPrefix;
  url += '?' + Ext.Object.toQueryString(urlParams);
  var data = record.data || {};
  data.tablePrefix = BpcCommon.Api.getSetting(this.moduleId, 'tableNameDetails');
  return Ext.Ajax.request({url:url, headers:{ISPortalUser:BpcCommon.Api.getUserName(), 'X-BPC-ModuleId':this.moduleId}, method:'POST', params:data}).then(function(response) {
    var json = flextable.Support.getResponseObject(response);
    if (json) {
      if (json.success) {
        BpcCommon.Api.showNotification(json.message ? json.message : 'Aktion wurde erfolgreich ausgeführt');
      } else {
        BpcCommon.Api.showNotification(json.message ? json.message : 'Fehler bei der Ausführung der Aktion');
      }
    } else {
      BpcCommon.Api.showNotification('Action: ' + action + ' - Fehler bei der Ausführung - Response Unexpected');
    }
  }, function(response) {
    BpcCommon.Api.showNotification('Action: ' + action + ' - Fehler bei der Ausführung');
  });
}, handleError:function(obj) {
  var v = this.getView();
  if (v) {
    v.setEmptyText(obj && obj.error || ' - ');
  }
}, getAttachmentDataIndex:function() {
  return BpcCommon.Api.getSetting(this.moduleId, 'fileColumn') || 'REFERENCE';
}, getAttachment:function(record) {
  var fileDataIndex = this.getAttachmentDataIndex();
  return record.get(fileDataIndex) || record.get(fileDataIndex.toUpperCase());
}, openAttachment:function(record) {
  var $jscomp$this = this;
  try {
    var r = record;
    var w = this.up('window'), t = undefined, idSuffix = 'fileViewerItemId';
    if (w) {
      t = w.down('tabpanel');
      if (t) {
        var params = flextable.file.getFileParameters(record, this.moduleId);
        var openViewer = t.down('#' + idSuffix + params.childid);
        if (openViewer) {
          t.setActiveTab(openViewer);
          return;
        }
      } else {
        return;
      }
    }
    var v = this.getView();
    v.setLoading(true);
    var wrapper, title = '', openAsTab = !!t;
    flextable.file.getFile(r, this.moduleId).then(function(data) {
      if (data) {
        wrapper = flextable.file.getViewer($jscomp$this.moduleId, data);
        if ($jscomp$this.moduleInstance.fileViewerMetaHidden) {
          wrapper.metaField.setVisible(false);
        }
        title = data.meta.childid ? flextable.Support.getTranslation('DOCUMENT_FROM_STEP') + ': ' + data.meta.childid : flextable.Support.getTranslation('DOCUMENT_PREVIEW');
      } else {
      }
    })['catch'](function(e) {
      title = flextable.Support.getTranslation('REQUEST_ERROR');
      var storeData = ['status', 'statusText', 'responseText'].map(function(k) {
        return {key:flextable.Support.getTranslation('ERROR_INFO_REQUEST_' + k.toUpperCase()), value:e[k] || '-1'};
      });
      if (e.request && e.request.url) {
        storeData.push({key:flextable.Support.getTranslation('ERROR_INFO_REQUEST_URL'), value:e.request.url});
      }
      wrapper = $jscomp$this.getErrorPanel(title, storeData, openAsTab);
    })['finally'](function() {
      v.setLoading(false);
      if (t) {
        t.add(wrapper);
        t.setActiveTab(wrapper);
      } else {
        Ext.create('Ext.window.Window', {title:title, height:document.body.clientHeight * 0.5, width:document.body.clientWidth * 0.7, iconCls:flextable.Support.getBpcIconCls('fa-file'), layout:'fit', items:[wrapper]}).show();
      }
    });
  } catch (e) {
  }
}, getErrorPanel:function(title, data, openAsTab) {
  data = data === undefined ? [] : data;
  return Ext.create({xtype:'panel', title:title, header:openAsTab, closable:openAsTab, iconCls:flextable.Support.getBpcIconCls('fa-exclamation-triangle'), layout:'fit', items:[{xtype:'grid', header:false, listeners:{rowdblclick:function(tableView, record) {
    if (flextable.Support.copyToClipBoard(record.get('value'), tableView)) {
      BpcCommon.Api.showNotification(record.get('key') + ' ' + flextable.Support.getTranslation('COPIED_SUCCESS'));
    }
  }}, store:Ext.create('Ext.data.Store', {data:data}), columns:[{dataIndex:'key', text:flextable.Support.getTranslation('KEY'), flex:1, menuDisabled:true}, {dataIndex:'value', text:flextable.Support.getTranslation('VALUE'), flex:3, menuDisabled:true}]}]});
}, getActionColumnConfig:function(moduleId) {
  var $jscomp$this = this;
  var mimetypeDataIndex = 'MIMETYPE', defaultMimetype = 'application/xml';
  var items = [{tooltip:flextable.Support.getTranslation('SHOW_DOCUMENT'), scope:this, handler:function(g, r, c, i, e, record) {
    $jscomp$this.openAttachment(record);
  }, isActionDisabled:function(view, rowIndex, colIndex, item, record) {
    return !$jscomp$this.getAttachment(record);
  }, getClass:function(value, metadata, record) {
    var mimeType = record.get(mimetypeDataIndex) || defaultMimetype;
    return flextable.Support.getBpcIconCls(flextable.Support.mimeTypeMap[mimeType] || 'fa-file');
  }}, {iconCls:flextable.Support.getBpcIconCls('fa-download'), tooltip:flextable.Support.getTranslation('DOWNLOAD_DOCUMENT'), handler:function(grid, row, c, i, e, r) {
    try {
      flextable.file.openFile(r, moduleId);
    } catch (e$0) {
      BpcCommon.Api.showNotification(flextable.Support.getTranslation('DOWNLOAD_ERROR'));
    }
  }, isActionDisabled:function(view, rowIndex, colIndex, item, record) {
    return !$jscomp$this.getAttachment(record);
  }}];
  return [{xtype:'actioncolumn', width:items.length * 30, items:items}];
}, createRenderer:function(cfg) {
  cfg = cfg || {};
  var isDate = Ext.isDefined(cfg.isDate) ? cfg.isDate : false;
  if (isDate) {
    var dateCfg = cfg;
    return function(v, m, r) {
      if (!v) {
        return '';
      }
      var rendererValue;
      if (dateCfg.autoParse === false) {
        var date = dateCfg.formatInput ? Ext.Date.parse(v, dateCfg.formatInput) : Ext.Date.parse(v);
        if (Ext.isDate(date)) {
          rendererValue = Ext.Date.format(date, dateCfg.format);
        } else {
          var splitted = v.split('+');
          if (splitted.length === 2) {
            var tzArray = splitted[1].split(':');
            if (tzArray[0].length === 1) {
              tzArray[0] = '0' + tzArray[0];
            }
            var timeZone = tzArray.join(':');
            var newDateString = splitted[0].trim() + '+' + timeZone;
            newDateString = newDateString.trim();
            var date2 = Ext.Date.parse(newDateString);
            if (date2) {
              rendererValue = Ext.Date.format(date2, dateCfg.format || 'd.m.Y');
            }
          }
        }
      }
      return rendererValue ? rendererValue : v || '';
    };
  }
  var iconOnly = Ext.isDefined(cfg.iconOnly) ? cfg.iconOnly : false;
  var map = cfg.valueMap || {};
  var renderIcon = function(cls, c) {
    return cls ? flextable.Support.getSpanForIconCls(cls, c) : undefined;
  };
  var compareLower = Ext.isDefined(cfg.compareLower) ? cfg.compareLower : false;
  return function(v, m, r) {
    var rendererValue;
    v = v || '';
    v = compareLower ? v.toLowerCase() : v;
    if (map[v]) {
      var item = map[v] || {};
      item = Ext.applyIf(item, {label:undefined, iconOnly:undefined, color:undefined});
      rendererValue = iconOnly ? renderIcon(item.iconCls, item.color) : (renderIcon(item.iconCls, item.color) || '') + ' ' + (item.label || v || '');
    }
    return rendererValue ? rendererValue : v;
  };
}, getColumnsFromSetting:function(mainOrDetails) {
  var $jscomp$this = this;
  var cfg = BpcCommon.Api.getSetting(this.moduleId, 'uiConfiguration') || {};
  var rendererCfg = cfg.renderer || {};
  if (cfg[mainOrDetails] && cfg[mainOrDetails].columns) {
    return cfg[mainOrDetails].columns.map(function(colCfg) {
      try {
        var renderer = colCfg.dataIndex && rendererCfg[colCfg.dataIndex] ? $jscomp$this.createRenderer(rendererCfg[colCfg.dataIndex] || {}) : undefined;
        if (renderer) {
          colCfg.renderer = renderer;
        }
      } catch (e) {
      }
      return colCfg;
    });
  }
}, changeExtraParams:function(params) {
  var p = this.store.getProxy().getExtraParams() || {};
  p = Ext.apply(p, params);
  this.store.getProxy().setExtraParams(p);
  this.store.load();
}, setColumnsFromRecord:function(rec) {
  var obj = rec ? rec.getData() : {};
  var columns = Object.keys(obj).filter(function(name) {
    return name !== 'id';
  }).map(function(name) {
    return {dataIndex:name, text:name, flex:1};
  });
  this.reconfigure(columns);
  this.store.addColumns = true;
}, updateTotal:function(num) {
  var total = num || this.store.getTotalCount();
  this.totalBtn.setText(String(total) + ' ' + flextable.Support.getTranslation('ROWS'));
}, getPluginDefinitions:function() {
  var h = Ext.createByAlias('widget.flextableGridActionHook', {hidden:true, context:{moduleId:'flextable', instanceId:this.moduleId}});
  return h.getPluginDefinitions();
}});
Ext.define('flextable.file', {singleton:true, getFileParameters:function(record, moduleId) {
  return {directory:record.get(BpcCommon.Api.getSetting(moduleId, 'fileColumn')) || null, processid:record.get(BpcCommon.Api.getSetting(moduleId, 'idColumnDetail')) || null, childid:record.get(BpcCommon.Api.getSetting(moduleId, 'idColumnDetailSub')) || null, prefix:BpcCommon.Api.getSetting(moduleId, 'tablePrefix') || null, mime:record.get(BpcCommon.Api.getSetting(moduleId, 'fileMimeColumn')) || null};
}, getFileUrl:function(record, moduleId) {
  var params = this.getFileParameters(record, moduleId);
  var proxyId = BpcCommon.Api.getSetting(moduleId, 'engineConnection') || '-1';
  var basePath = BpcCommon.Api.getSetting(moduleId, 'engineBasePath') || '';
  var fileListener = BpcCommon.Api.getSetting(moduleId, 'fileListener') || '';
  var prefix = BpcCommon.Api.getBackendUrl(proxyId) || '';
  return prefix + basePath + fileListener + '?' + Ext.Object.toQueryString(params);
}, getFileResponse:function(url) {
  return flextable.Support.getAjaxPromise({method:'get', url:url});
}, getFile:function(record, moduleId) {
  var url = this.getFileUrl(record, moduleId);
  return this.getFileResponse(url).then(function(response) {
    if (response && response.responseText) {
      return {file:response.responseText, meta:flextable.file.getFileParameters(record, moduleId), record:record, fileSource:response.responseText, fileUrl:url};
    }
  });
}, openFile:function(record, moduleId) {
  window.open(this.getFileUrl(record, moduleId), '_blank');
}, getViewer:function(moduleId, data, idSuffix) {
  data = data === undefined ? {} : data;
  idSuffix = idSuffix === undefined ? 'fileViewerItemId' : idSuffix;
  var fileData = data.file || '';
  if (data.meta.mime) {
    data.meta.forceViewUrl = ['image/png', 'image/jpeg', 'image/bmp', 'image/gif', 'image/jpg', 'application/pdf'].indexOf(data.meta.mime) !== -1;
    data.meta.isXml = data.file.trim().startsWith('\x3c');
  } else {
    fileData = fileData.trim();
    if (fileData.startsWith('\x3c')) {
      data.meta.mime = 'text/xml';
      data.meta.isXml = true;
      data.meta.mimeGuess = true;
    } else {
      if (fileData.split("'").length > 2) {
        data.meta.mime = 'application/edifact';
        data.meta.mimeGuess = true;
      }
    }
  }
  if (data.meta.isXml) {
    data.file = flextable.Support.prettyXml(fileData);
    data.treeView = Ext.create({xtype:'ftTree', fileSource:data.fileSource});
  } else {
    if (data.meta.mime === 'application/edifact') {
      data.file = fileData.split("'").map(function(i) {
        return i.trim();
      }).join("'\r\n");
    } else {
      if (fileData.split("'").length > 2) {
        data.file = fileData.split("'").map(function(i) {
          return i.trim();
        }).join("'\r\n");
      }
    }
  }
  return Ext.create({xtype:'ftFileViewer', moduleId:moduleId, idSuffix:idSuffix, fileObject:data});
}});
Ext.define('flextable.components.fileViewer.FileViewer', {extend:'Ext.panel.Panel', alias:'widget.ftFileViewer', closable:true, iconCls:flextable.Support.getBpcIconCls('fa-file'), header:false, layout:'card', moduleId:undefined, idSuffix:undefined, fileObject:{}, showNotification:function(msg, level) {
  var $jscomp$this = this;
  level = level === undefined ? 'i' : level;
  this.notificationField.update(msg);
  Ext.defer(function() {
    $jscomp$this.notificationField.update('');
  }, 2000);
}, initComponent:function() {
  var $jscomp$this = this;
  this.itemId = this.idSuffix + this.fileObject.meta.childid;
  this.title = this.fileObject.meta.childid ? flextable.Support.getTranslation('DOCUMENT_FROM_STEP') + ': ' + this.fileObject.meta.childid : flextable.Support.getTranslation('DOCUMENT_PREVIEW');
  this.notificationField = Ext.create({xtype:'container'});
  if (this.fileObject.meta) {
    this.metaView = this.createMetaViewer();
  }
  this.metaField = Ext.create({text:flextable.Support.getTranslation('META'), ui:'secondary', xtype:'button', margin:'0 0 0 0', handler:function(b) {
    $jscomp$this.setActiveCard($jscomp$this.metaView);
  }});
  this.dockedItems = [{xtype:'toolbar', dock:'top', padding:'3 0 3 0', items:[{text:'HTML', disabled:true, hidden:true}, {text:flextable.Support.getTranslation('ORIGINAL'), iconCls:flextable.Support.getBpcIconCls('fa-file'), margin:'0 2 0 0', ui:'primary', overCls:'', focusCls:'', handler:function() {
    $jscomp$this.setActiveCard($jscomp$this.baseViewer.displayText());
  }}, {text:flextable.Support.getTranslation('FORMAT'), iconCls:flextable.Support.getBpcIconCls('fa-align-justify'), ui:'primary', margin:'0 2 0 0', overCls:'', focusCls:'', handler:function() {
    $jscomp$this.setActiveCard($jscomp$this.baseViewer.displayText('formatted'));
  }}, {text:flextable.Support.getTranslation('TREEVIEW'), iconCls:flextable.Support.getBpcIconCls('fa-folder-tree'), ui:'primary', margin:'0 2 0 0', hidden:!this.fileObject.meta.isXml, overCls:'', focusCls:'', handler:function() {
    $jscomp$this.setActiveCard($jscomp$this.fileObject.treeView);
  }}, {xtype:'tbfill'}, this.notificationField, {xtype:'tbfill'}, {iconCls:flextable.Support.getBpcIconCls('fa-copy'), text:flextable.Support.getTranslation('COPY'), ui:'secondary', margin:'0 2 0 0', handler:function(b) {
    var card = $jscomp$this.getLayout().getActiveItem();
    if (card.getValue) {
      if (flextable.Support.copyToClipBoard(card.getValue(), card)) {
        $jscomp$this.showNotification(flextable.Support.getTranslation('COPIED_SUCCESS'));
      }
    }
  }}, {iconCls:flextable.Support.getBpcIconCls('fa-download'), text:flextable.Support.getTranslation('DOWNLOAD'), ui:'secondary', margin:'0 2 0 0', disabled:!Ext.isDefined(this.moduleId) || this.moduleId === null, handler:function() {
    flextable.file.openFile($jscomp$this.fileObject.record, $jscomp$this.moduleId);
  }}, this.metaField]}];
  this.baseViewer = this.createBaseViewer();
  this.items = [this.baseViewer];
  this.callParent(arguments);
}, setActiveCard:function(card) {
  this.getLayout().setActiveItem(card);
}, createBaseViewer:function() {
  var textView = Ext.create({xtype:'ftText', value:this.fileObject.file ? this.fileObject.file : this.fileObject.fileSource || '-1', readOnly:true});
  return Ext.create({xtype:'container', itemId:'flexFileView', layout:'fit', fileData:this.fileObject, items:[textView], getValue:function() {
    return textView.getValue();
  }, displayText:function(mode) {
    mode = mode === undefined ? 'original' : mode;
    if (mode === 'original') {
      textView.setValue(this.fileData.fileSource || '-1');
    } else {
      if (mode === 'formatted') {
        textView.setValue(this.fileData.file || '-1');
      }
    }
    return this;
  }});
}, createMetaViewer:function() {
  this.metaView = Ext.create({xtype:'ftFileMeta', fileObject:this.fileObject, viewer:this});
  return this.metaView;
}});
Ext.define('flextable.components.fileViewer.Meta', {extend:'Ext.panel.Panel', alias:'widget.ftFileMeta', moduleId:undefined, fileObject:{}, header:false, flex:1, layout:'fit', hidden:true, scrollable:true, initComponent:function() {
  var metaObject = this.fileObject.meta || {};
  var $jscomp$destructuring$var4 = metaObject;
  var directory = $jscomp$destructuring$var4.directory;
  directory = directory || '';
  var filename = this.getFileNameFromDirectory(directory);
  if (filename) {
    this.updateNotificationField(flextable.Support.getTranslation('FILE') + ': ' + filename);
    metaObject.filename = filename;
  }
  var storeData = Object.keys(metaObject).map(function(k) {
    return {key:k.toUpperCase(), value:metaObject[k] || ''};
  });
  this.items = [{xtype:'grid', store:Ext.create('Ext.data.Store', {data:storeData}), listeners:{rowdblclick:function(tv, rec) {
    var textValue = rec.get('value') || '';
    if (textValue.length > 0 && flextable.Support.copyToClipBoard(textValue, tv)) {
      BpcCommon.Api.showNotification(textValue + ' ' + flextable.Support.getTranslation('COPIED_SUCCESS'));
    }
  }}, columns:[{dataIndex:'key', renderer:function(v) {
    v = v || '';
    return v.length ? '\x3cb\x3e' + v + '\x3c/b\x3e' : v;
  }}, {dataIndex:'value', flex:1}, {xtype:'actioncolumn', width:40, items:[{iconCls:flextable.Support.getBpcIconCls('fa-clone'), tooltip:flextable.Support.getTranslation('COPY'), handler:function(tv, row, c, i, e, r) {
    var textValue = r.get('value') || '';
    if (textValue.length > 0 && flextable.Support.copyToClipBoard(textValue, tv)) {
      BpcCommon.Api.showNotification(textValue + ' ' + flextable.Support.getTranslation('COPIED_SUCCESS'));
    }
  }}]}]}];
  this.callParent(arguments);
}, updateNotificationField:function(str) {
  this.viewer.notificationField.update(str);
}, getFileNameFromDirectory:function(dir) {
  dir = dir === undefined ? '' : dir;
  if (dir.indexOf(':') !== -1) {
    var parts = dir.split(':');
    if (parts.length > 1) {
      var filePart = parts[1] || '';
      if (filePart.indexOf('/') !== -1) {
        var folders = filePart.split('/');
        if (folders.length > 1) {
          var file = folders[1] || '';
          if (file.length) {
            return file;
          }
        }
      }
    }
  }
}});
Ext.define('flextable.components.fileViewer.Text', {extend:'Ext.panel.Panel', alias:'widget.ftText', layout:'fit', editor:undefined, value:undefined, readOnly:false, initComponent:function() {
  this.editorId = Ext.id();
  var wrapper = Ext.create({xtype:'container', html:'\x3cdiv style\x3d"height: 100%;width: 100%"\x3e\x3cdiv style\x3d"height: 100%;width: 100%" id\x3d"' + this.editorId + '"\x3e\x3c/div\x3e\x3c/div\x3e'});
  this.items = [wrapper];
  this.listeners = {afterrender:this.initEditor.bind(this), beforedestroy:this.destroyEditor.bind(this), resize:this.onResize.bind(this)};
  this.callParent(arguments);
}, initEditor:function() {
  var $jscomp$this = this;
  if (!window.ace) {
    lazyLoad.Ace().then(function() {
      $jscomp$this.initEditor();
    });
    return;
  }
  this.editor = ace.edit(this.editorId);
  this.editor.setTheme('ace/theme/chrome');
  this.editor.getSession().setMode('ace/mode/xml');
  this.editor.setOptions({enableBasicAutocompletion:true, enableLiveAutocompletion:true, showLineNumbers:true, showPrintMargin:false});
  if (this.readOnly) {
    this.editor.setReadOnly(true);
  }
  if (this.value) {
    this.setValue(this.value);
  }
}, onResize:function() {
  if (this.editor) {
    this.editor.resize();
  }
}, getValue:function() {
  if (this.editor) {
    return this.editor.getValue();
  }
}, setValue:function(value) {
  if (this.editor) {
    this.editor.setValue(value, -1);
  }
}, destroyEditor:function() {
  if (this.editor) {
    this.editor.destroy.bind(this.editor);
  }
}});
Ext.define('flextable.components.fileViewer.Tree', {extend:'Ext.tree.Panel', alias:'widget.ftTree', viewConfig:{enableTextSelection:true}, rootVisible:false, scrollable:true, fileSource:undefined, initComponent:function() {
  var $jscomp$this = this;
  var path = Ext.create({xtype:'button', iconCls:flextable.Support.getBpcIconCls('fa-code-branch')});
  var xmlData = this.parseXML(this.fileSource.replace(/<([a-zA-Z0-9]+)(?:xml)ns=".*"(.*)>/g, '\x3c$1$2\x3e').replace(/^\s/, ''));
  var childNode = CSS.escape(xmlData.childNodes[0].nodeName);
  var treeData = Ext.DomQuery.selectNode(childNode, xmlData);
  this.store = Ext.create('Ext.data.TreeStore', {root:{expanded:true, children:this.nodeToJsonTree(treeData)}});
  this.bbar = [path];
  this.listeners = {select:function(treeModel, node) {
    Ext.log({dump:node, msg:'select'});
    Ext.log({dump:node.getPath(), msg:'path'});
    var pathString = node.getPath();
    var recordIds = pathString.split('/');
    var namedPath = recordIds.map(function(name) {
      if (name === 'root') {
        return name;
      } else {
        var r = $jscomp$this.store.getById(name);
        if (r) {
          return r.get('text');
        }
        return name;
      }
    });
    path.setText(namedPath.join('/'));
  }, rowdblclick:function(tv, rec) {
    var textValue = rec.get('rawValue') || '';
    if (textValue.length > 0 && flextable.Support.copyToClipBoard(textValue, tv)) {
      BpcCommon.Api.showNotification(textValue + ' ' + flextable.Support.getTranslation('COPIED_SUCCESS'));
    }
  }};
  this.callParent(arguments);
  this.expandAll();
}, columns:[{xtype:'treecolumn', text:'Baum', dataIndex:'text', flex:4}, {text:'Item', dataIndex:'text', hidden:true, flex:1, renderer:function(val, meta, rec) {
  var textValue = rec.get('text') || '';
  return textValue.trim().indexOf(':') !== -1 ? textValue.split(':')[0] : textValue;
}}, {text:'Value', dataIndex:'text', hidden:true, flex:2, renderer:function(val, meta, rec) {
  var textValue = rec.get('text') || '';
  return textValue.trim().indexOf(':') !== -1 ? textValue.split(':')[1] : '';
}}], parseXML:function(dataInString) {
  if (window.DOMParser) {
    return (new window.DOMParser).parseFromString(dataInString, 'text/xml');
  } else {
    if (typeof window.ActiveXObject !== 'undefined' && new window.ActiveXObject('Microsoft.XMLDOM')) {
      var xmlDoc = new window.ActiveXObject('Microsoft.XMLDOM');
      xmlDoc.async = 'false';
      xmlDoc.loadXML(dataInString);
      return xmlDoc;
    }
  }
  return null;
}, nodeToJsonTree:function(node) {
  var jsonTree = {text:node.nodeName, draggable:false};
  var textValue = '';
  Ext.each(node.childNodes, function(item) {
    if (item.nodeType === 3 && item.textContent.trim() !== '') {
      textValue = textValue + item.textContent.trim() + ' ';
      textValue = textValue.replace(/</g, '\x26lt;');
      textValue = textValue.replace(/>/g, '\x26gt;');
    }
  }, this);
  var attributes = '';
  if (node.attributes) {
    for (var i = 0; i < node.attributes.length; i++) {
      attributes = attributes + node.attributes.item(i).name + '\x3d' + node.attributes.item(i).value + ' ';
    }
  }
  if (attributes.length > 0) {
    jsonTree.text = jsonTree.text + ' (' + attributes + ')';
  }
  if (textValue.length > 0) {
    jsonTree.text = jsonTree.text + ' : \x3cb\x3e' + textValue + '\x3c/b\x3e';
    jsonTree.rawValue = textValue || '';
  }
  if (!node.childElementCount || node.childElementCount < 1) {
    jsonTree.leaf = true;
    jsonTree.iconCls = '';
    jsonTree.icon = Ext.BLANK_IMAGE_URL;
  } else {
    jsonTree.leaf = false;
    jsonTree.icon = Ext.BLANK_IMAGE_URL;
    jsonTree.children = [];
    Ext.each(node.childNodes, function(node) {
      if (node.nodeType !== 3) {
        jsonTree.children.push(this.nodeToJsonTree(node));
      }
    }, this);
  }
  return jsonTree;
}});
Ext.define('flextable.moduleConfigurationComponents.Main', {extend:'BpcCommon.component.panel.moduleConfigurationComponents.Wrapper', alias:'widget.flextableConfigMain', initComponent:function() {
  this.callParent(arguments);
  this.setIconCls(BpcCommon.util.Icons.getBpcIconCls('fa-database'));
  this.setTitle(flextable.Support.getTranslation('FLEXTABLE_ADMIN'));
  this.saveButton.setVisible(false);
  this.resetButton.setVisible(false);
}, onSelect:function(grid, record) {
  this.settingsWrapper.removeAll();
  var moduleId = record.get('moduleId');
  this.settingsWrapper.add({xtype:'flextableTable', moduleId:moduleId, header:false});
}, getRendererConfig:function(moduleId) {
  var $jscomp$destructuring$var5 = BpcCommon.Api.getSetting(moduleId, flextable.Support.keys.cfg) || {};
  var renderer = $jscomp$destructuring$var5.renderer;
  return renderer || {};
}});
Ext.define('flextable.manager.Renderer', {extend:'Ext.panel.Panel', alias:'widget.flextableRenderer', title:'Renderer', viewConfig:{enableTextSelection:true}, layout:{type:'vbox', align:'stretch'}, initComponent:function() {
  var $jscomp$this = this;
  var conf = BpcCommon.Api.getSetting(this.moduleId, flextable.Support.keys.cfg) || {};
  var $jscomp$destructuring$var6 = conf;
  var renderer = $jscomp$destructuring$var6.renderer;
  var main = $jscomp$destructuring$var6.main;
  var details = $jscomp$destructuring$var6.details;
  renderer = renderer || {};
  main = main || {};
  details = details || {};
  var rendererNames = Object.keys(renderer || {});
  this.rendererStoreData = rendererNames.map(function(name) {
    var map = renderer[name].valueMap || {};
    return {id:name, data:Object.keys(map).map(function(value) {
      var item = map[value] || {};
      item.value = value;
      return item;
    })};
  });
  this.rendererGrid = Ext.create({title:'\x3e ' + (rendererNames.length ? rendererNames[0] : flextable.Support.getTranslation('NO_RENDERER_DEFINED')), xtype:'grid', flex:1, viewConfig:{emptyText:flextable.Support.getTranslation('NO_DATA')}, store:Ext.create('Ext.data.Store', {data:rendererNames.length ? this.rendererStoreData.filter(function(item) {
    return item.id === rendererNames[0];
  })[0].data : []}), columns:['value', 'label', 'iconCls', 'color'].map(function(id) {
    var col = {dataIndex:id, text:id.toUpperCase(), flex:id === 'label' || id === 'value' ? 2 : 1};
    if (id === 'iconCls') {
      col.renderer = function(v, m, r) {
        return flextable.Support.getSpanForIconCls(v, r.get('color'));
      };
    }
    return col;
  }).concat([{xtype:'actioncolumn', width:60, items:[{iconCls:flextable.Support.getBpcIconCls('fa-copy'), handler:function(tv, rowIndex, colIndex) {
    var data = tv.store.getAt(rowIndex).getData();
    tv.store.add({value:data.value || '', iconCls:data.iconCls || '', label:data.label || '', color:data.color || '#eee'});
  }}, {iconCls:flextable.Support.getBpcIconCls('fa-times'), handler:function(tv, rowIndex, colIndex) {
    tv.store.removeAt(rowIndex);
  }}]}]), tbar:[{xtype:'checkbox', margin:'0 0 0 5', boxLabel:flextable.Support.getTranslation('ICON_ONLY')}, {xtype:'checkbox', margin:'0 0 0 5', boxLabel:flextable.Support.getTranslation('COMPARE_LOWER')}, {xtype:'tbfill'}, {text:flextable.Support.getTranslation('ADD_EMPTY')}, {text:flextable.Support.getTranslation('ADD_MATCH_ALL_FALLBACK')}], bbar:[{text:'Usages: '}, {xtype:'tbfill'}, {iconCls:flextable.Support.getBpcIconCls('fa-save')}]});
  this.items = [this.rendererGrid];
  var getCount = function(cols, dataIndex) {
    cols = cols || [];
    return cols.filter(function(col) {
      return col.dataIndex === dataIndex;
    }).length;
  };
  var getTitle = function(dataIndex) {
    return '\x3e ' + dataIndex;
  };
  this.tbar = rendererNames.map(function(name) {
    return {text:name, rendererBtn:true, scope:$jscomp$this, handler:function(b) {
      this.rendererGrid.store.removeAll();
      this.rendererGrid.setTitle(getTitle(b.text));
      this.rendererGrid.store.add(this.rendererStoreData.filter(function(item) {
        return item.id === b.text;
      })[0].data || []);
    }};
  }).concat([{xtype:'tbfill'}, {text:flextable.Support.getTranslation('REMOVE_ALL'), handler:function(btn) {
    this.rendererGrid.setTitle(flextable.Support.getTranslation('NO_RENDERER'));
    this.rendererGrid.store.removeAll();
    this.rendererStoreData = [];
    this.query('button[rendererBtn]').map(function(b) {
      return b.destroy();
    });
  }.bind(this)}]);
  this.callParent(arguments);
}});
Ext.define('flextable.manager.Table', {extend:'Ext.panel.Panel', alias:'widget.flextableTable', layout:{type:'vbox', align:'stretch'}, initComponent:function() {
  var $jscomp$this = this;
  this.title = flextable.Support.getTranslation('CONNECTION_INFO');
  this.iconCls = flextable.Support.getBpcIconCls('fa-ethernet');
  this.connectionInfoPanelToolbar = Ext.create({xtype:'toolbar'});
  this.schemaCatalogLoadButton = Ext.create({xtype:'button', iconCls:flextable.Support.getBpcIconCls('fa-sync'), text:'Schemas \x26 Catalogs', handler:function() {
    $jscomp$this.loadSchemasAndCatalogs();
  }, disabled:true});
  this.tablesViewsLoadButton = Ext.create({xtype:'button', iconCls:flextable.Support.getBpcIconCls('fa-sync'), text:'Tables \x26 Views', handler:function() {
    $jscomp$this.loadTablesAndViews();
  }});
  this.connectionHandlerToolbar = Ext.create({xtype:'toolbar', items:[this.schemaCatalogLoadButton, this.tablesViewsLoadButton]});
  this.connectionInfoPanel = Ext.create({xtype:'fieldset', title:flextable.Support.getTranslation('CONNECTION_DETAILS'), layout:'fit', items:[this.connectionInfoPanelToolbar]});
  this.primaryStore = Ext.create('Ext.data.Store', {data:[]});
  this.columnStore = Ext.create('Ext.data.Store', {data:[]});
  this.schemaFieldSet = Ext.create(this.getFieldsetColumn(flextable.Support.getTranslation('TABLES_SCHEMAS'), 'schemaName', [{dataIndex:'TABLE_SCHEM', flex:1}, {dataIndex:'TABLE_CATALOG', flex:1, hidden:true}], 'TABLE_SCHEM'));
  this.catalogsFieldSet = Ext.create(this.getFieldsetColumn(flextable.Support.getTranslation('TABLES_CATALOGS'), 'catalogName', [{dataIndex:'TABLE_CAT', flex:1}], 'TABLE_CAT'));
  var cfg = this.getFieldsetColumn(flextable.Support.getTranslation('TABLES_VIEWS'), 'tableViewName', [{dataIndex:'TABLE_NAME', flex:1}, {dataIndex:'type'}], 'TABLE_NAME', [{iconCls:flextable.Support.getBpcIconCls('fa-plus'), handler:function() {
    Ext.create('Ext.window.Window', {title:'Hello', height:document.body.clientHeight * 0.2, width:document.body.clientWidth * 0.5, layout:'fit', items:[{xtype:'textfield'}], bbar:[{xtype:'tbfill'}, {iconCls:flextable.Support.getBpcIconCls('fa-save')}]}).show();
  }}]);
  cfg.selectField.on('change', function(f, newVal) {
    $jscomp$this.primaryStore.removeAll();
    $jscomp$this.columnStore.removeAll();
    if (newVal && newVal.length) {
      flextable.Api.getTableMeta($jscomp$this.moduleId, newVal).then(function(obj) {
        $jscomp$this.primaryStore.add(obj.tableColumnPrimaryKeys || []);
        $jscomp$this.columnStore.add(obj.tableColumnDetails || []);
      });
    }
  });
  this.tableViewsFieldSet = Ext.create(cfg);
  this.items = [this.connectionInfoPanel, this.connectionHandlerToolbar, {xtype:'panel', flex:2, layout:{type:'hbox', align:'stretch'}, items:[this.schemaFieldSet, this.catalogsFieldSet, this.tableViewsFieldSet, {xtype:'fieldset', flex:2, title:flextable.Support.getTranslation('TABLE_DETAILS'), layout:{type:'vbox', align:'stretch'}, items:[{xtype:'grid', viewConfig:{emptyText:flextable.Support.getTranslation('NO_DATA')}, minHeight:100, title:flextable.Support.getTranslation('PRIMARY_KEYS'), iconCls:flextable.Support.getBpcIconCls('fa-star-of-life'), 
  store:this.primaryStore, style:'border:0px!important;', columns:[{dataIndex:'COLUMN_NAME', flex:1}, {dataIndex:'PK_NAME', flex:1}]}, {xtype:'grid', flex:2, title:flextable.Support.getTranslation('COLUMN_INFO'), iconCls:flextable.Support.getBpcIconCls('fa-columns'), store:this.columnStore, style:'border:0px!important;', viewConfig:{emptyText:flextable.Support.getTranslation('NO_DATA')}, columns:[{dataIndex:'COLUMN_NAME', flex:1}, {dataIndex:'DATA_TYPE'}, {dataIndex:'IS_AUTOINCREMENT', hidden:true}, 
  {dataIndex:'IS_NULLABLE', hidden:true}, {dataIndex:'COLUMN_SIZE', hidden:true}]}]}]}];
  this.callParent(arguments);
  this.loadDriverData();
}, getFieldsetColumn:function(title, itemId, columns, selectRecordField, buttons) {
  columns = columns === undefined ? [] : columns;
  buttons = buttons === undefined ? [] : buttons;
  var selectField = Ext.create({xtype:'textfield', emptyText:title, itemId:itemId + 'Field', flex:1});
  var totalBtn = Ext.create({xtype:'button', iconCls:flextable.Support.getBpcIconCls('fa-database'), text:'0'});
  var grid = Ext.create({xtype:'grid', style:'border:0px!important;', viewConfig:{emptyText:flextable.Support.getTranslation('NO_DATA')}, tbar:[selectField], bbar:buttons.concat([{xtype:'tbfill'}, totalBtn]), store:Ext.create('Ext.data.Store', {data:[], listeners:{datachanged:function(s) {
    totalBtn.setText('' + s.getCount());
  }}}), columns:columns, listeners:{select:function(selModel, r) {
    selectField.setValue(r.get(selectRecordField));
  }}});
  return {xtype:'fieldset', title:title, flex:1, layout:'fit', selectField:selectField, grid:grid, itemId:itemId, items:[grid]};
}, loadTablesAndViews:function() {
  var $jscomp$this = this;
  this.tableViewsFieldSet.grid.store.removeAll();
  flextable.Api.getTablesViews(this.moduleId, {mode:'tablesViews', schemaName:this.schemaFieldSet.selectField.getValue()}).then(function(data) {
    var storeData = (data.tables || []).concat(data.views || []);
    $jscomp$this.tableViewsFieldSet.grid.store.add(storeData);
  });
}, loadSchemasAndCatalogs:function() {
  var $jscomp$this = this;
  flextable.Api.getSchemas(this.moduleId).then(function(data) {
    $jscomp$this.schemaFieldSet.grid.store.add(data.schemas || []);
  }).then(function() {
    return flextable.Api.getCatalogs($jscomp$this.moduleId);
  }).then(function(data) {
    $jscomp$this.catalogsFieldSet.grid.store.add(data.catalogs || []);
  });
}, loadDriverData:function() {
  var $jscomp$this = this;
  this.setLoading(flextable.Support.getTranslation('FETCHING_DATA'));
  flextable.Api.getDriverInfo(this.moduleId).then(function(connectionObject) {
    var driver = (connectionObject || {}).driver || {};
    Object.keys(driver).map(function(propName) {
      $jscomp$this.connectionInfoPanelToolbar.add({xtype:'textfield', fieldLabel:flextable.Support.getTranslation('DB_' + propName), value:driver[propName] || '-1', readOnly:true, flex:1});
    });
  }).then(function() {
    $jscomp$this.schemaCatalogLoadButton.setDisabled(false);
  })['catch'](function(e) {
  })['finally'](function() {
    $jscomp$this.setLoading(false);
  });
}});
Ext.define('flextable.plugin.BpcPluginMixin', {getValueFromPluginConfiguration:function(key, fromContext) {
  if (this.pluginConfiguration && Ext.isObject(this.pluginConfiguration)) {
    if (!fromContext) {
      if (this.pluginConfiguration.configuration && Ext.isObject(this.pluginConfiguration.configuration)) {
        var pluginConfig = this.pluginConfiguration.configuration;
        if (key in pluginConfig && pluginConfig[key]) {
          return pluginConfig[key];
        }
      }
    } else {
      if (fromContext) {
        if (this.pluginConfiguration.context && Ext.isObject(this.pluginConfiguration.context)) {
          var ctx = this.pluginConfiguration.context;
          if (key in ctx && ctx[key]) {
            return ctx[key];
          }
        }
      }
    }
  }
}, isCmpUsedAsPlugin:function() {
  var me = this;
  return 'pluginConfiguration' in me && me.pluginConfiguration && Ext.isObject(me.pluginConfiguration);
}});
Ext.define('flextable.plugin.detailWindow.Main', {extend:'Ext.panel.Panel', alias:'widget.flextablePlugin', mixins:['flextable.plugin.BpcPluginMixin'], layout:'fit', padding:'5 5 5 5', idValue:undefined, legacy:false, flexTableParams:undefined, previewFileWrapperItemId:undefined, baseTitle:'', forceActiveTab:false, initComponent:function() {
  var $jscomp$this = this;
  this.iconCls = flextable.Support.getBpcIconCls(this.getValueFromPluginConfiguration('iconCls') || 'fa-database');
  this.moduleId = this.getValueFromPluginConfiguration('moduleId') || undefined;
  var pTargetModuleId = this.getValueFromPluginConfiguration('instanceId', true);
  var rec = this.getValueFromPluginConfiguration('record', true);
  this.baseTitle = this.getValueFromPluginConfiguration('title');
  this.idValue = rec.get(BpcCommon.Api.getSetting(pTargetModuleId, 'column_id'));
  this.pluginSortColumn = this.getValueFromPluginConfiguration('sortColumn') || BpcCommon.Api.getSetting(this.moduleId, 'sortColumn');
  this.pluginSortDirection = this.getValueFromPluginConfiguration('sortDirection') || BpcCommon.Api.getSetting(this.moduleId, 'sortDirection');
  this.previewFileWrapperItemId = this.getValueFromPluginConfiguration('previewFileWrapperItemId');
  var forceActiveTab = this.getValueFromPluginConfiguration('forceActiveTab');
  if (forceActiveTab === true) {
    this.forceActiveTab = true;
  }
  var metaHidden = this.getValueFromPluginConfiguration('fileViewer_metaHidden');
  this.flextable = Ext.create({xtype:'flextableMain', isBpcModule:false, moduleId:this.moduleId, fileViewerMetaHidden:metaHidden === true, showToolbars:false, idKey:Ext.isDefined(this.idValue) ? false : undefined, onTableCreated:this.onTableCreated.bind(this)});
  this.listeners = {added:function(c, owner) {
    var types = owner.getXTypes();
    types = types.split('/').map(function(t) {
      return t.toLowerCase();
    });
    if ($jscomp$this.forceActiveTab && types.indexOf('tabpanel') !== -1) {
      Ext.defer(function() {
        owner.setActiveTab(c);
      }, 1000);
      return;
    } else {
      var layout = owner.getLayout();
      if (layout && layout.config) {
        var $jscomp$destructuring$var7 = layout;
        var config = $jscomp$destructuring$var7.config;
        config = config || {};
        var $jscomp$destructuring$var8 = config;
        var type = $jscomp$destructuring$var8.type;
        type = type || '';
        if (type === 'hbox' || type === 'vbox') {
          c.setFlex(1);
          return;
        }
      }
      if (c.header) {
        c.header.hide();
      } else {
        c.header = false;
      }
    }
  }};
  this.items = [this.flextable];
  this.callParent(arguments);
  this.updateTitle();
}, onTableCreated:function() {
  var $jscomp$this = this;
  if (Ext.isDefined(this.idValue)) {
    this.flextable.grid.changeExtraParams({idValue:this.idValue});
    this.flextable.grid.flexContext = {processId:this.idValue};
  }
  this.flextable.grid.store.on('load', function(s, records, success) {
    if ($jscomp$this.pluginSortColumn && $jscomp$this.pluginSortColumn.length) {
      s.sort({property:$jscomp$this.pluginSortColumn, direction:$jscomp$this.pluginSortDirection});
    }
    $jscomp$this.updateTitle(success ? records.length : 0);
    if (success) {
      if ($jscomp$this.previewFileWrapperItemId) {
        if ($jscomp$this.ownerCt) {
          var win = $jscomp$this.ownerCt.up('window');
          if (win) {
            var wrapper = win.down('#' + $jscomp$this.previewFileWrapperItemId);
            if (wrapper) {
              wrapper.removeAll();
              var storeData = $jscomp$this.getAttachments(records);
              storeData = storeData.map(function(o) {
                var newObj = Ext.apply({}, o.r.getData());
                if (newObj.id) {
                  delete newObj.id;
                }
                return newObj;
              });
              wrapper.add({xtype:'grid', store:Ext.create('Ext.data.Store', {data:storeData}), columns:$jscomp$this.flextable.grid.getActionColumnConfig($jscomp$this.moduleId).concat([{dataIndex:'REFERENZ', text:'Referenz', flex:1}, {dataIndex:'MIMETYPE', text:'Mime', flex:1}])});
            }
          }
        }
      }
    }
  });
  this.flextable.load();
}, getAttachments:function(records) {
  var $jscomp$this = this;
  records = records === undefined ? [] : records;
  records = records.map(function(r) {
    return {r:r, attachment:$jscomp$this.flextable.grid.getAttachment(r)};
  }).filter(function(o) {
    return Ext.isDefined(o.attachment) && o.attachment !== null;
  });
  return records;
}, updateTitle:function(num) {
  num = num || 0;
  var prefix = this.baseTitle || 'FLEXTABLE';
  this.setTitle(prefix + ' ( ' + num + ' ) ');
}});
Ext.define('flextable.plugin.detailWindow.Wrapper', {extend:'BpcCommon.plugin.Interface', inheritableStatics:{NAME:'Flextable Plugin', COMPONENT_XTYPE:'flextablePlugin', PLUGIN_ID:'flextable-detailwindow-plugin'}});
Ext.define('flextable.plugin.hooks.Base', {extend:'BpcCommon.plugin.HookContainer', context:undefined, autoInjectPlugins:false, pluginComponentDefinitions:[], hidden:true, assetConfiguration:undefined, initComponent:function() {
  Ext.isDefined(this.assetConfiguration) ? this.context.assetConfig = this.assetConfiguration : undefined;
  var pluginComponents = [];
  try {
    pluginComponents = BpcCommon.Api.getPluginComponents(this, this.context) || [];
  } catch (e) {
    pluginComponents = [];
  }
  if (Ext.isArray(pluginComponents)) {
    this.enrichPlugins(pluginComponents);
  }
  this.callParent(arguments);
}, getPluginDefinitions:function() {
  return this.pluginComponentDefinitions || [];
}, enrichPlugins:function(pluginComponents) {
  pluginComponents = pluginComponents === undefined ? [] : pluginComponents;
  this.pluginComponentDefinitions = pluginComponents.map(function(obj) {
    return obj;
  });
}});
Ext.define('flextable.plugin.hooks.GridActions', {extend:'flextable.plugin.hooks.Base', alias:'widget.flextableGridActionHook', inheritableStatics:{NAME:'Flextable Action Hook', HOOK_ID:'flextable_grid_actions', HOOK_LEVEL:'instance'}});
Ext.define('flextable.view.Main', {extend:'Ext.panel.Panel', alias:'widget.flextableMain', layout:'fit', moduleId:undefined, idKey:undefined, showToolbars:true, initColumns:undefined, isBpcModule:true, header:false, fileViewerMetaHidden:undefined, initComponent:function() {
  var $jscomp$this = this;
  var idKey = this.idKey === false ? undefined : this.idKey || BpcCommon.Api.getSetting(this.moduleId, flextable.Support.keys.id);
  if (this.isBpcModule) {
    this.addBpcModuleFeatures();
  }
  this.callParent(arguments);
  flextable.Support.preloadPluginModules(this.moduleId).then(function(config) {
    if (config) {
    }
    $jscomp$this.createTable(idKey);
    $jscomp$this.load();
  });
}, createTable:function(idKey) {
  this.grid = Ext.create({xtype:'flextableGrid', moduleId:this.moduleId, moduleInstance:this, idKey:idKey, mode:this.idKey === false ? 'details' : undefined});
  this.add(this.grid);
  this.onTableCreated();
}, onTableCreated:function() {
}, addBpcModuleFeatures:function() {
  this.bpcModuleHeader = Ext.createByAlias('widget.flextableModuleHeader', {moduleId:this.moduleId, moduleInstance:this});
  this.applicationToolbarRight = Ext.create({xtype:'toolbar', layout:{pack:'end'}, items:[{scope:this, handler:this.load, tooltip:flextable.Support.getTranslation('REFRESH'), iconCls:flextable.Support.getBpcIconCls('fa-sync')}]});
}, load:function() {
  this.grid.store.load();
}, getColumn:function(dataIndex) {
  return this.grid.getColumns().filter(function(col) {
    return col.dataIndex === dataIndex;
  }).map(function(col) {
    return {text:col.text || col.header || '', dataIndex:dataIndex, renderer:col.renderer || undefined};
  });
}});
Ext.define('flextable.view.ModuleHeader', {extend:'Ext.container.Container', alias:'widget.flextableModuleHeader', layout:{type:'hbox', align:'stretch'}, moduleId:undefined, initComponent:function() {
  this.items = [];
  this.callParent(arguments);
}});
